=== debian/changelog ===
rocthrust (6.1.2-1~exp1) experimental; urgency=medium

  * New upstream version 6.1.2
  * Update build deps' minimum required versions
  * Standards-Version 4.7.0
  * Add myself to uploaders

 -- Kari Pahula <kaol@debian.org>  Wed, 27 Nov 2024 17:12:48 +0200

rocthrust (5.7.1-3) unstable; urgency=medium

  * Acknowledge NMU. Thanks, Gianfranco Costamanga!

  * autopkgtest: Explicit name for Test-Command test
  * autopkgtest: Save dmesg and amdgpu_firmware_info as artifacts

 -- Christian Kastner <ckk@debian.org>  Tue, 23 Apr 2024 18:26:49 +0200
